/*
 * Programa para calcular o instante de chegada de um dado voo
 * entradas: Instante de partida (hhp,mmp,ssp)
 *           Duração do voo (hhd,mmd,ssd)
 *           Diferença horária entre origem e o destino (difHor)
 * saída: Instante de chegada (dd,hhc,mmc,ssc)
 */

#include <stdio.h>


void somarHoras(int hh1, int mm1, int ss1,
		int hh2, int mm2, int ss2,
		int *hh, int *mm, int *ss) {
  /*
   * Procedimento para somar dois instantes de tempo, não considera a
   * mudança de dias.
   * 
   * entradas: Dois instantes de tempo
   * saída: Resultado da soma
   */
  
  int mmAux,ssAux;

  ssAux = ss1+ss2;
  *ss = ssAux % 60;
  mmAux = mm1+mm2+(ssAux / 60);
  *mm = mmAux % 60;
  *hh = hh1+hh2+(mmAux / 60);
}

void ajuste(int* dd, int* hh){
  /* 
   * Procedimento para fazer o ajuste referente as mudanças de dia.
   *
   * entrada: horas (valor eventualmente maior do que 23)
   * saídas: dias e horas (entre 0 e 23)
   */

  if (hh < 0) {
    *hh = 24+*hh;
    *dd = -1;
  }
  else {
    *dd = *hh / 24;
    *hh = *hh % 24;
  }
}

int main() {

  int hhp,mmp,ssp;
  int hhd,mmd,ssd;
  int difHor;
  int hhc,mmc,ssc;
  int hhAux,mmAux,ssAux;
  int dd;

  // Leitura
  printf("Instante de Partida (hh,mm,ss): ");
  scanf("%d%d%d",&hhp,&mmp,&ssp);
  printf("Duração do Voo (hh,mm,ss): ");
  scanf("%d%d%d",&hhd,&mmd,&ssd);
  printf("Diferença Horária (hh): ");
  scanf("%d",&difHor);
  // Cálculo, Instante de partida + duração
  somarHoras(hhp,mmp,ssp,hhd,mmd,ssd,&hhAux,&mmAux,&ssAux);
  // Cálculo (Instante de partida + duração) + Fusos
  somarHoras(hhAux,mmAux,ssAux,difHor,0,0,&hhc,&mmc,&ssc);
  // Ajuste do valor achado, cálculo da mudança de dia 
  ajuste(&dd,&hhc);
  // Escrita do resultado 
  printf("\nO avião chegou às, ");
  if (dd == 0) {
    printf("%dh %dm %ds\n",hhc,mmc,ssc);
  }
  else {
    switch (dd) {
    case -1: 
      printf("%dh %dm %ds.\n",hhc,mmc,ssc);
      printf("Do dia anterior.\n");
      break;
    case 1: 
      printf("%dh %dm %ds.\n",hhc,mmc,ssc);
      printf("Do dia seguinte.\n");
      break;
    default:
      printf("Erro\n");
    }
  }
  return 0;
}
